/* IMPORT */
import { toKebabCase } from 'kasi';
/* MAIN */
const escapeHTML = (() => {
    const replacementsRe = /[&<>"]/g;
    const replacements = { '&': '&amp;', '<': '&lt;', '>': '&gt;', '"': '&quot;', "'": '&#39;' };
    const replaceChar = (char) => {
        return replacements[char];
    };
    const replaceChars = (str) => {
        return str.replace(replacementsRe, replaceChar);
    };
    return replaceChars;
})();
const memoize = (fn) => {
    const cache = new Map();
    return (...args) => {
        const id = args[0];
        const resultCached = cache.get(id);
        if (resultCached !== undefined || cache.has(id))
            return resultCached;
        const result = fn.apply(undefined, args);
        cache.set(id, result);
        return result;
    };
};
/* EXPORT */
export { escapeHTML, memoize, toKebabCase };
